library IEEE;
  use IEEE.std_logic_1164.all;
  use IEEE.numeric_std.all;
  use IEEE.std_logic_unsigned.all;

package spi_lib is
    
  constant SPI_DATA_WIDTH_C    : integer := 32;
  constant SPI_PACKET_LENGTH_C : integer := 32;
  constant SPI_CHECKSUM_C      : boolean := true;
  
  type spi_data_t is
    record
      data  : std_logic_vector(SPI_DATA_WIDTH_C - 1 downto 0);
      valid : std_logic;
    end record;

  function XOR_ALL(vec: std_logic_vector) return std_logic;
    
end package;

package body spi_lib is

  function XOR_ALL(vec: std_logic_vector) return std_logic is
    variable ret: std_logic;
  begin
    ret := '0';
    for i in vec'left to vec'right loop
      ret := ret xor vec(i);
    end loop;
    return ret;
  end function;
  
end package body;